// WINTPOD.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <windowsx.h>
#include <objbase.h>
#include <stdio.h>
#include <atlbase.h>

	interface ITrackerPod : IDispatch
	{
		virtual HRESULT __stdcall initialize()					 = 0;
		virtual HRESULT __stdcall move()						 = 0;
		virtual HRESULT __stdcall get_x(float *pVal)			 = 0;
		virtual HRESULT __stdcall put_x(float newVal)			 = 0;
		virtual HRESULT __stdcall get_y(float *pVal)			 = 0;
		virtual HRESULT __stdcall put_y(float newVal)			 = 0;
		virtual HRESULT __stdcall get_move_method(short *pVal)	 = 0;
		virtual HRESULT __stdcall put_move_method(short newVal)	 = 0;
		virtual HRESULT __stdcall get_app_name(BSTR *pVal)		 = 0;
		virtual HRESULT __stdcall put_app_name(BSTR newVal)		 = 0;
		virtual HRESULT __stdcall put_control_cmd(BSTR newVal)	 = 0;
		virtual HRESULT __stdcall get_control_result(long *pVal) = 0;
		virtual HRESULT __stdcall get_tpod_info(BSTR *pVal)		 = 0;
	};

const IID IID_ITrackerPod = {0x7C9D31C6,0x03C0,0x421E,{0xBF,0x7B,0x16,0x0A,0xB5,0x17,0xB6,0x54}};
const CLSID CLSID_TrackerPod = {0x4DDE2928,0x74A4,0x4309,{0xAC,0x89,0x90,0x15,0xCA,0x3B,0xD9,0xB4}};
ITrackerPod *g_pTrackerPod = NULL;

int g_xPos, g_yPos; 
HINSTANCE	g_hInstance = NULL;
BOOL CALLBACK DialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	switch (msg)
	{
	case WM_COMMAND:
		if(LOWORD (wParam) == IDOK)
		{
			EndDialog(hwnd, TRUE);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_INITIALIZE)
		{
			char client_id[100];
			GetDlgItemText(hwnd, IDC_EDIT_CLIENT_ID, client_id, sizeof(client_id) - 1);

			if(client_id[0] == '\0')
			{
				MessageBox(hwnd, "Please type in client ID", "wintpod", MB_OK);
				break;
			}

			if(g_pTrackerPod->put_app_name(CComBSTR(client_id)) != S_OK)
			{
				MessageBox(hwnd, "!g_pTrackerPod->app_name", "wintpod", MB_OK);
				break;
			}

			if(g_pTrackerPod->initialize() == S_OK)
			{
				HWND but_init = GetDlgItem(hwnd, IDC_BUTTON_INITIALIZE);
				HWND edt_clid = GetDlgItem(hwnd, IDC_EDIT_CLIENT_ID);
				EnableWindow(but_init, FALSE);
				EnableWindow(edt_clid, FALSE);
			}
			else
				MessageBox(hwnd, "Failed to initialize!", "wintpod", MB_OK);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_GET_POS)
		{
			float x, y;
			if(g_pTrackerPod->get_x(&x) == S_OK && g_pTrackerPod->get_y(&y) == S_OK)
			{
				HWND hwnd_pos = GetDlgItem(hwnd, IDC_STATIC_POS);
				char szHello[256];
				sprintf(szHello, "%5.2f %5.2f", x, y);
				SetWindowText(hwnd_pos, szHello);
			}

			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_LEFT)
		{
			g_pTrackerPod->put_move_method(0);
			g_pTrackerPod->put_x(10);
			g_pTrackerPod->put_y(0);
			g_pTrackerPod->move();
			break;
		}


		if(LOWORD (wParam) == IDC_BUTTON_RIGHT)
		{
			g_pTrackerPod->put_move_method(0);
			g_pTrackerPod->put_x(-10);
			g_pTrackerPod->put_y(0);
			g_pTrackerPod->move();
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_UP)
		{
			g_pTrackerPod->put_move_method(0);
			g_pTrackerPod->put_x(0);
			g_pTrackerPod->put_y(-10);
			g_pTrackerPod->move();
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_DOWN)
		{
			g_pTrackerPod->put_move_method(0);
			g_pTrackerPod->put_x(0);
			g_pTrackerPod->put_y(10);
			g_pTrackerPod->move();
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_HOME)
		{
			g_pTrackerPod->put_move_method(1);
			g_pTrackerPod->put_x(0);
			g_pTrackerPod->put_y(0);
			g_pTrackerPod->move();
			break;
		}


		if(LOWORD (wParam) == IDC_SEND_ZOOM2)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 100)
				val = 100;

			if(val > 26000)
				val = 26000;

			sprintf(szValue, "%d", val);
			char move_ext_cmd[1024];

			sprintf(move_ext_cmd, "optical_zoom=%s", szValue);
			CComBSTR bstr_cmd(move_ext_cmd);

			if(g_pTrackerPod->put_control_cmd(bstr_cmd) != S_OK)
			{
			}
		}

		if(LOWORD (wParam) == IDC_SEND_ZOOM3)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM3, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 0)	val = 0;
			if(val > 6)	val = 6;

			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "LANC_zoom_speed=%d", val);
			CComBSTR bstr_cmd(move_ext_cmd);

			if(g_pTrackerPod->put_control_cmd(bstr_cmd) != S_OK)
			{
			}
		}

		if(LOWORD (wParam) == IDC_BUTTON_GETINFO)
		{
			CComBSTR bstr_info;
			if(g_pTrackerPod->get_tpod_info(&bstr_info) == S_OK)
			{
				char info[1024];
				WideCharToMultiByte(CP_ACP, 0, bstr_info, -1, (char *)info, sizeof(info), NULL, NULL);
				SetDlgItemText(hwnd, IDC_EDIT_INFO, info);
			}
			else
				SetDlgItemText(hwnd, IDC_EDIT_INFO, "cannot get info");
			break;
		}


		if(HIWORD (wParam) == CBN_SELCHANGE)
		{
			if(GetDlgCtrlID((HWND)lParam) == IDC_COMBO_CONTROL)
			{
				DWORD cursel = ComboBox_GetCurSel((HWND)lParam);
				char ctrl_text[256];
				ComboBox_GetLBText((HWND)lParam, cursel, ctrl_text);
				SetWindowText(hwnd, ctrl_text);
				CComBSTR bstr_cmd(ctrl_text);

				long ret;
				if(g_pTrackerPod->put_control_cmd(bstr_cmd) == S_OK)
				{

					if(g_pTrackerPod->get_control_result(&ret) == S_OK)
					{
						char result[256];
						sprintf(result, "%s : %d", ctrl_text, ret);
						SetDlgItemText(hwnd, IDC_STATIC_CONTROL, result);
					}
				}
			}
		}

		break;

	case WM_INITDIALOG:
		{
			HWND hwnd_control = GetDlgItem(hwnd, IDC_COMBO_CONTROL);
			ComboBox_AddString(hwnd_control, "led=on");
			ComboBox_AddString(hwnd_control, "led=off");

			ComboBox_AddString(hwnd_control, "buffering=on");
			ComboBox_AddString(hwnd_control, "buffering=off");
			ComboBox_AddString(hwnd_control, "flushbuffer");

			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=1");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=2");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=3");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=4");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=5");

			ComboBox_AddString(hwnd_control, "zoom=in");
			ComboBox_AddString(hwnd_control, "zoom=out");
			ComboBox_AddString(hwnd_control, "zoom=home");

			ComboBox_AddString(hwnd_control, "focus=far");
			ComboBox_AddString(hwnd_control, "focus=near");

			ComboBox_AddString(hwnd_control, "zoom_step_size=1");
			ComboBox_AddString(hwnd_control, "zoom_step_size=2");
			ComboBox_AddString(hwnd_control, "zoom_step_size=3");
			ComboBox_AddString(hwnd_control, "zoom_step_size=4");
			ComboBox_AddString(hwnd_control, "zoom_step_size=5");
			ComboBox_AddString(hwnd_control, "zoom_step_size=6");
			ComboBox_AddString(hwnd_control, "zoom_step_size=7");
			ComboBox_AddString(hwnd_control, "zoom_step_size=8");
			ComboBox_AddString(hwnd_control, "zoom_step_size=9");
			ComboBox_AddString(hwnd_control, "zoom_step_size=10");

			ComboBox_AddString(hwnd_control, "auto_focus=on");
			ComboBox_AddString(hwnd_control, "auto_focus=off");

			ComboBox_AddString(hwnd_control, "digital_zoom=on");
			ComboBox_AddString(hwnd_control, "digital_zoom=off");

			ComboBox_AddString(hwnd_control, "LANC_toggle_auto_focus");
			ComboBox_AddString(hwnd_control, "LANC_toggle_record");
			ComboBox_SetCurSel(hwnd_control, 0);
		}
		return TRUE;
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		EndPaint(hwnd, &ps);
		return 0;
	case WM_SIZE:
		return TRUE;
	case WM_CLOSE:
		EndDialog(hwnd, TRUE);
		break;

	case WM_LBUTTONDOWN:
		{
			g_xPos = GET_X_LPARAM(lParam); 
			g_yPos = GET_Y_LPARAM(lParam); 
			SetCapture(hwnd);
			break;
		}

	case WM_LBUTTONUP:
		{
			ReleaseCapture();
			break;
		}
	case WM_MOUSEMOVE:
		{
			if(wParam == MK_LBUTTON)
			{
				int xPos = GET_X_LPARAM(lParam); 
				int yPos = GET_Y_LPARAM(lParam); 
				int dx = xPos - g_xPos;
				int dy = yPos - g_yPos;

				g_pTrackerPod->put_move_method(0);
				g_pTrackerPod->put_x(-dx / 2);
				g_pTrackerPod->put_y(dy / 2);
				g_pTrackerPod->move();

				g_xPos = xPos;
				g_yPos = yPos;
			}

			break;
		}
	}
	return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.

	CoInitialize(NULL);

	HRESULT hr = CoCreateInstance( CLSID_TrackerPod, NULL, CLSCTX_INPROC_SERVER,
					IID_ITrackerPod, (void**) &g_pTrackerPod);

	if(hr != S_OK || !g_pTrackerPod)
	{
		CoInitialize(NULL);
		MessageBox(NULL, "Failed to initialize the component", "error", MB_OK);
		return 0;
	}

	g_hInstance = hInstance;
	DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_TRACKERPOD_TEST), NULL, (DLGPROC)DialogProc);

	if(g_pTrackerPod)
		g_pTrackerPod->Release();
	g_pTrackerPod = NULL;

	CoUninitialize();
	return 0;
}

