// WINTPOD.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <windowsx.h>
#include <objbase.h>
#include <stdio.h>
#include <atlbase.h>

	interface ITrackerPodC : IUnknown
	{
		virtual HRESULT __stdcall initialize(BSTR app_name)	  = 0;
		virtual HRESULT __stdcall move_to(float x, float y)   = 0;
		virtual HRESULT __stdcall move_by(float x, float y)   = 0;
		virtual HRESULT __stdcall get_pos(float *x, float *y) = 0;
		virtual HRESULT __stdcall devcontrol(BSTR cmd, long *result) = 0;
		virtual HRESULT __stdcall get_info(BSTR *pVal)				 = 0;
	};

const IID IID_ITrackerPodC = {0x69493CE5,0x967E,0x4A62,{0xA4,0xD4,0xDD,0x9F,0x88,0x74,0xC0,0x4A}};
const CLSID CLSID_TrackerPod = {0x4DDE2928,0x74A4,0x4309,{0xAC,0x89,0x90,0x15,0xCA,0x3B,0xD9,0xB4}};
ITrackerPodC *g_pTrackerPod = NULL;


int g_xPos, g_yPos; 
HINSTANCE	g_hInstance = NULL;
BOOL CALLBACK DialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	switch (msg)
	{
	case WM_COMMAND:
		if(LOWORD (wParam) == IDOK)
		{
			EndDialog(hwnd, TRUE);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_INITIALIZE)
		{
			char client_id[100];
			GetDlgItemText(hwnd, IDC_EDIT_CLIENT_ID, client_id, sizeof(client_id) - 1);

			if(client_id[0] == '\0')
			{
				MessageBox(hwnd, "Please type in client ID", "wintpod", MB_OK);
				break;
			}
			

			CComBSTR bstr_client(client_id);
			if(g_pTrackerPod->initialize((BSTR)bstr_client) == S_OK)
			{
				HWND but_init = GetDlgItem(hwnd, IDC_BUTTON_INITIALIZE);
				HWND edt_clid = GetDlgItem(hwnd, IDC_EDIT_CLIENT_ID);
				EnableWindow(but_init, FALSE);
				EnableWindow(edt_clid, FALSE);
			}
			else
				MessageBox(hwnd, "Failed to initialize!", "wintpod", MB_OK);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_GET_POS)
		{
			float x, y;
			if(g_pTrackerPod->get_pos(&x, &y) == S_OK)
			{
				HWND hwnd_pos = GetDlgItem(hwnd, IDC_STATIC_POS);
				char szHello[256];
				sprintf(szHello, "%5.2f %5.2f", x, y);
				SetWindowText(hwnd_pos, szHello);
			}

			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_LEFT)
		{
			g_pTrackerPod->move_by(+10, 0);
			break;
		}


		if(LOWORD (wParam) == IDC_BUTTON_RIGHT)
		{
			g_pTrackerPod->move_by(-10, 0);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_UP)
		{
			g_pTrackerPod->move_by(0, -10);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_DOWN)
		{
			g_pTrackerPod->move_by(0, 10);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_HOME)
		{
			g_pTrackerPod->move_to(0, 0);
			break;
		}

		if(LOWORD (wParam) == IDC_SEND_ZOOM2)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 100)
				val = 100;

			if(val > 26000)
				val = 26000;

			sprintf(szValue, "%d", val);
			char move_ext_cmd[1024];

			sprintf(move_ext_cmd, "optical_zoom=%s", szValue);
			CComBSTR bstr_cmd(move_ext_cmd);

			long ret = 0;
			if(g_pTrackerPod->devcontrol(bstr_cmd, &ret) != S_OK)
			{
			}

			if(!ret)
			{

			}
		}

		if(LOWORD (wParam) == IDC_SEND_ZOOM3)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM3, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 0)	val = 0;
			if(val > 6)	val = 6;

			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "LANC_zoom_speed=%d", val);
			CComBSTR bstr_cmd(move_ext_cmd);

			long ret = 0;
			if(g_pTrackerPod->devcontrol(bstr_cmd, &ret) != S_OK)
			{

			}

			if(!ret)
			{

			}
		}

		if(LOWORD (wParam) == IDC_BUTTON_GETINFO)
		{
			CComBSTR bstr_info;
			if(g_pTrackerPod->get_info(&bstr_info) == S_OK)
			{
				char info[1024];
				WideCharToMultiByte(CP_ACP, 0, bstr_info, -1, (char *)info, sizeof(info), NULL, NULL);
				SetDlgItemText(hwnd, IDC_EDIT_INFO, info);
			}
			else
				SetDlgItemText(hwnd, IDC_EDIT_INFO, "cannot get info");
			break;
		}

		if(HIWORD (wParam) == CBN_SELCHANGE)
		{

			if(GetDlgCtrlID((HWND)lParam) == IDC_COMBO_CONTROL)
			{
				DWORD cursel = ComboBox_GetCurSel((HWND)lParam);
				char ctrl_text[256];
				ComboBox_GetLBText((HWND)lParam, cursel, ctrl_text);
				SetWindowText(hwnd, ctrl_text);
				CComBSTR bstr_cmd(ctrl_text);

				long ret;
				if(g_pTrackerPod->devcontrol(bstr_cmd, &ret) == S_OK)
				{
					char result[256];
					sprintf(result, "%s : %d", ctrl_text, ret);
					SetDlgItemText(hwnd, IDC_STATIC_CONTROL, result);
				}
			}

			break;
		}
		return TRUE;

	case WM_INITDIALOG:
		{
			HWND hwnd_control = GetDlgItem(hwnd, IDC_COMBO_CONTROL);
			ComboBox_AddString(hwnd_control, "led=on");
			ComboBox_AddString(hwnd_control, "led=off");

			ComboBox_AddString(hwnd_control, "buffering=on");
			ComboBox_AddString(hwnd_control, "buffering=off");
			ComboBox_AddString(hwnd_control, "flushbuffer");

			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=1");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=2");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=3");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=4");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=5");

			ComboBox_AddString(hwnd_control, "zoom=in");
			ComboBox_AddString(hwnd_control, "zoom=out");
			ComboBox_AddString(hwnd_control, "zoom=home");

			ComboBox_AddString(hwnd_control, "focus=far");
			ComboBox_AddString(hwnd_control, "focus=near");

			ComboBox_AddString(hwnd_control, "zoom_step_size=1");
			ComboBox_AddString(hwnd_control, "zoom_step_size=2");
			ComboBox_AddString(hwnd_control, "zoom_step_size=3");
			ComboBox_AddString(hwnd_control, "zoom_step_size=4");
			ComboBox_AddString(hwnd_control, "zoom_step_size=5");
			ComboBox_AddString(hwnd_control, "zoom_step_size=6");
			ComboBox_AddString(hwnd_control, "zoom_step_size=7");
			ComboBox_AddString(hwnd_control, "zoom_step_size=8");
			ComboBox_AddString(hwnd_control, "zoom_step_size=9");
			ComboBox_AddString(hwnd_control, "zoom_step_size=10");

			ComboBox_AddString(hwnd_control, "auto_focus=on");
			ComboBox_AddString(hwnd_control, "auto_focus=off");

			ComboBox_AddString(hwnd_control, "digital_zoom=on");
			ComboBox_AddString(hwnd_control, "digital_zoom=off");

			ComboBox_AddString(hwnd_control, "LANC_toggle_auto_focus");
			ComboBox_AddString(hwnd_control, "LANC_toggle_record");
			ComboBox_SetCurSel(hwnd_control, 0);
		}
		return TRUE;
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		EndPaint(hwnd, &ps);
		return 0;
	case WM_SIZE:
		return TRUE;
	case WM_CLOSE:
		EndDialog(hwnd, TRUE);
		break;

	case WM_LBUTTONDOWN:
		{
			g_xPos = GET_X_LPARAM(lParam); 
			g_yPos = GET_Y_LPARAM(lParam); 
			SetCapture(hwnd);
			break;
		}

	case WM_LBUTTONUP:
		{
			ReleaseCapture();
			break;
		}
	case WM_MOUSEMOVE:
		{
			if(wParam == MK_LBUTTON)
			{
				int xPos = GET_X_LPARAM(lParam); 
				int yPos = GET_Y_LPARAM(lParam); 
				int dx = xPos - g_xPos;
				int dy = yPos - g_yPos;
				g_pTrackerPod->move_by(-dx/2, dy/2);
				g_xPos = xPos;
				g_yPos = yPos;
			}

			break;
		}
	}
	return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.

	CoInitialize(NULL);

	HRESULT hr = CoCreateInstance( CLSID_TrackerPod, NULL, CLSCTX_INPROC_SERVER,
					IID_ITrackerPodC, (void**) &g_pTrackerPod);

	if(hr != S_OK || !g_pTrackerPod)
	{
		CoInitialize(NULL);
		MessageBox(NULL, "Failed to initialize the component", "error", MB_OK);
		return 0;
	}

	g_hInstance = hInstance;
	DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_TRACKERPOD_TEST), NULL, (DLGPROC)DialogProc);

	if(g_pTrackerPod)
		g_pTrackerPod->Release();
	g_pTrackerPod = NULL;

	CoUninitialize();
	return 0;
}

