// WINTPOD.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <windowsx.h>
#include <objbase.h>
#include <atlbase.h>
#include <stdio.h>

const CLSID CLSID_TrackerPod = {0x4DDE2928,0x74A4,0x4309,{0xAC,0x89,0x90,0x15,0xCA,0x3B,0xD9,0xB4}};

IDispatch* g_pIDispatch = NULL;

BOOL set_app_name(char *client_id, IDispatch *pIDispatch)
{
	OLECHAR* name = L"app_name";
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	VARIANTARG param;
	VariantInit(&param);

	CComBSTR bstr(client_id);

	param.vt      = VT_BSTR;
	param.bstrVal = bstr;

	DISPID mydispid = DISPID_PROPERTYPUT;

	DISPPARAMS param_list = { &param, &mydispid, 1, 1 };
	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_PROPERTYPUT, 
						&param_list, 
						NULL, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
	{
		VariantClear(&param); 
		return FALSE;
	}

	VariantClear(&param); 
	return TRUE;
}

BOOL set_control_cmd(char *cmd, IDispatch *pIDispatch)
{
	OLECHAR* name = L"control_cmd";
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	VARIANTARG param;
	VariantInit(&param);

	CComBSTR bstr(cmd);

	param.vt      = VT_BSTR;
	param.bstrVal = bstr;

	DISPID mydispid = DISPID_PROPERTYPUT;

	DISPPARAMS param_list = { &param, &mydispid, 1, 1 };
	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_PROPERTYPUT, 
						&param_list, 
						NULL, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
	{
		VariantClear(&param); 
		return FALSE;
	}

	VariantClear(&param); 
	return TRUE;
}

BOOL get_control_result(long *val, IDispatch *pIDispatch)
{
	OLECHAR* name = L"control_result";
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	DISPPARAMS param_list = { 0, 0, 0, 0 };

	VARIANT result;
	VariantInit(&result);
	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_PROPERTYGET, 
						&param_list, 
						&result, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
		return FALSE;

	*val = result.lVal;
	return TRUE;
}


BOOL set_move_method(short val, IDispatch *pIDispatch)
{
	OLECHAR* name = L"move_method";
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	VARIANTARG param;

	VariantInit(&param);
	param.vt = VT_I4;
	param.lVal = val;

	DISPID mydispid = DISPID_PROPERTYPUT;

	DISPPARAMS param_list = { &param, &mydispid, 1, 1 };
	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_PROPERTYPUT, 
						&param_list, 
						NULL, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
		return FALSE;
	return TRUE;
}

BOOL initialize(IDispatch *pIDispatch)
{
	OLECHAR* name = L"initialize";
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	DISPPARAMS param_list = { 0, 0, 0, 0 };

	VARIANT result;
	VariantInit(&result);

	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_METHOD, 
						&param_list, 
						&result, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
		return FALSE;

	return TRUE;
}

BOOL set_pos(float val, IDispatch *pIDispatch, wchar_t *method)
{
	OLECHAR* name = method;
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	VARIANTARG param;

	VariantInit(&param);
	param.vt = VT_R4;
	param.fltVal = val;

	DISPID mydispid = DISPID_PROPERTYPUT;

	DISPPARAMS param_list = { &param, &mydispid, 1, 1 };

	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_PROPERTYPUT, 
						&param_list, 
						NULL, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
		return FALSE;

	return TRUE;
}

BOOL get_pos(float *val, IDispatch *pIDispatch, wchar_t *method)
{
	OLECHAR* name = method;
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	DISPPARAMS param_list = { 0, 0, 0, 0 };

	VARIANT result;
	VariantInit(&result);
	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_PROPERTYGET, 
						&param_list, 
						&result, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
		return FALSE;

	*val = result.fltVal;
	return TRUE;
}


BOOL get_info(CComBSTR &val, IDispatch *pIDispatch)
{
	OLECHAR* name = L"tpod_info";
	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	DISPPARAMS param_list = { 0, 0, 0, 0 };

	VARIANT result;
	VariantInit(&result);
	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_PROPERTYGET, 
						&param_list, 
						&result, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
		return FALSE;

	val = result.bstrVal;
	return TRUE;
}



BOOL move_trackerpod(IDispatch *pIDispatch)
{
	OLECHAR* name = L"move";

	DISPID dispid;
	if(pIDispatch->GetIDsOfNames(IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid) != S_OK)
		return FALSE;

	DISPPARAMS param_list = { 0, 0, 0, 0 };

	VARIANT result;
	VariantInit(&result);

	HRESULT ret = pIDispatch->Invoke
					(
						dispid, 
						IID_NULL, 
						GetUserDefaultLCID(), 
						DISPATCH_METHOD, 
						&param_list, 
						&result, 
						NULL, 
						NULL
					);

	if(ret != S_OK)
		return FALSE;

	return TRUE;
}

int g_xPos, g_yPos; 
HINSTANCE	g_hInstance = NULL;
BOOL CALLBACK DialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	switch (msg)
	{
	case WM_COMMAND:
		if(LOWORD (wParam) == IDOK)
		{
			EndDialog(hwnd, TRUE);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_INITIALIZE)
		{
			char client_id[100];
			GetDlgItemText(hwnd, IDC_EDIT_CLIENT_ID, client_id, sizeof(client_id) - 1);

			if(client_id[0] == '\0')
			{
				MessageBox(hwnd, "Please type in client ID", "wintpod", MB_OK);
				break;
			}

			if(!set_app_name(client_id, g_pIDispatch))
				break;

			if(initialize(g_pIDispatch))
			{
				HWND but_init = GetDlgItem(hwnd, IDC_BUTTON_INITIALIZE);
				HWND edt_clid = GetDlgItem(hwnd, IDC_EDIT_CLIENT_ID);
				EnableWindow(but_init, FALSE);
				EnableWindow(edt_clid, FALSE);
			}
			else
				MessageBox(hwnd, "Failed to initialize!", "wintpod", MB_OK);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_GET_POS)
		{
			float x, y;
			if(get_pos(&x, g_pIDispatch, L"x") && get_pos(&y, g_pIDispatch, L"y"))
			{
				HWND hwnd_pos = GetDlgItem(hwnd, IDC_STATIC_POS);
				char szHello[256];
				sprintf(szHello, "%5.2f %5.2f", x, y);
				SetWindowText(hwnd_pos, szHello);
			}

			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_LEFT)
		{
			set_move_method(0, g_pIDispatch);
			set_pos(+10.0, g_pIDispatch, L"x");
			set_pos(0,   g_pIDispatch, L"y");
			move_trackerpod(g_pIDispatch);
			break;
		}


		if(LOWORD (wParam) == IDC_BUTTON_RIGHT)
		{
			set_move_method(0, g_pIDispatch);
			set_pos(-10.0, g_pIDispatch, L"x");
			set_pos(0,   g_pIDispatch, L"y");
			move_trackerpod(g_pIDispatch);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_UP)
		{
			set_move_method(0, g_pIDispatch);
			set_pos(0, g_pIDispatch, L"x");
			set_pos(-10.0,   g_pIDispatch, L"y");
			move_trackerpod(g_pIDispatch);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_DOWN)
		{
			set_move_method(0, g_pIDispatch);
			set_pos(0, g_pIDispatch, L"x");
			set_pos(10.0,   g_pIDispatch, L"y");
			move_trackerpod(g_pIDispatch);
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_HOME)
		{
			set_move_method(1, g_pIDispatch);
			set_pos(0, g_pIDispatch, L"x");
			set_pos(0, g_pIDispatch, L"y");
			move_trackerpod(g_pIDispatch);

			break;
		}


		if(LOWORD (wParam) == IDC_SEND_ZOOM2)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM2, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 100)
				val = 100;

			if(val > 26000)
				val = 26000;

			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "optical_zoom=%d", val);
			if(set_control_cmd(move_ext_cmd, g_pIDispatch))
			{
			}
			break;
		}

		if(LOWORD (wParam) == IDC_SEND_ZOOM3)
		{
			char szValue[256];
			GetDlgItemText(hwnd, IDC_EDIT_ZOOM3, szValue, sizeof(szValue) - 1);
			if(szValue[0] == '\0')
				break;

			int val = atol(szValue);

			if(val < 0)	val = 0;
			if(val > 6)	val = 6;

			char move_ext_cmd[1024];
			sprintf(move_ext_cmd, "LANC_zoom_speed=%d", val);
			if(set_control_cmd(move_ext_cmd, g_pIDispatch))
			{
			}
			break;
		}

		if(LOWORD (wParam) == IDC_BUTTON_GETINFO)
		{
			CComBSTR val;
			if(get_info(val, g_pIDispatch))
			{
				char info[1024];
				WideCharToMultiByte(CP_ACP, 0, val, -1, (char *)info, sizeof(info), NULL, NULL);
				SetDlgItemText(hwnd, IDC_EDIT_INFO, info);
			}
			else
				SetDlgItemText(hwnd, IDC_EDIT_INFO, "cannot get info");
			break;
		}


		if(HIWORD (wParam) == CBN_SELCHANGE)
		{
			if(GetDlgCtrlID((HWND)lParam) == IDC_COMBO_CONTROL)
			{
				DWORD cursel = ComboBox_GetCurSel((HWND)lParam);
				char ctrl_text[256];
				ComboBox_GetLBText((HWND)lParam, cursel, ctrl_text);
				SetWindowText(hwnd, ctrl_text);

				long ret;
				if(set_control_cmd(ctrl_text, g_pIDispatch))
				{
					if(get_control_result(&ret, g_pIDispatch))
					{
						char result[256];
						sprintf(result, "%s : %d", ctrl_text, ret);
						SetDlgItemText(hwnd, IDC_STATIC_CONTROL, result);
					}
				}
			}
		}

		return TRUE;
		

	case WM_INITDIALOG:
		{
			HWND hwnd_control = GetDlgItem(hwnd, IDC_COMBO_CONTROL);
			ComboBox_AddString(hwnd_control, "led=on");
			ComboBox_AddString(hwnd_control, "led=off");

			ComboBox_AddString(hwnd_control, "buffering=on");
			ComboBox_AddString(hwnd_control, "buffering=off");
			ComboBox_AddString(hwnd_control, "flushbuffer");

			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=1");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=2");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=3");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=4");
			ComboBox_AddString(hwnd_control, "pan_tilt_step_size=5");

			ComboBox_AddString(hwnd_control, "zoom=in");
			ComboBox_AddString(hwnd_control, "zoom=out");
			ComboBox_AddString(hwnd_control, "zoom=home");

			ComboBox_AddString(hwnd_control, "focus=far");
			ComboBox_AddString(hwnd_control, "focus=near");

			ComboBox_AddString(hwnd_control, "zoom_step_size=1");
			ComboBox_AddString(hwnd_control, "zoom_step_size=2");
			ComboBox_AddString(hwnd_control, "zoom_step_size=3");
			ComboBox_AddString(hwnd_control, "zoom_step_size=4");
			ComboBox_AddString(hwnd_control, "zoom_step_size=5");
			ComboBox_AddString(hwnd_control, "zoom_step_size=6");
			ComboBox_AddString(hwnd_control, "zoom_step_size=7");
			ComboBox_AddString(hwnd_control, "zoom_step_size=8");
			ComboBox_AddString(hwnd_control, "zoom_step_size=9");
			ComboBox_AddString(hwnd_control, "zoom_step_size=10");

			ComboBox_AddString(hwnd_control, "auto_focus=on");
			ComboBox_AddString(hwnd_control, "auto_focus=off");

			ComboBox_AddString(hwnd_control, "digital_zoom=on");
			ComboBox_AddString(hwnd_control, "digital_zoom=off");

			ComboBox_AddString(hwnd_control, "LANC_toggle_auto_focus");
			ComboBox_AddString(hwnd_control, "LANC_toggle_record");

			ComboBox_SetCurSel(hwnd_control, 0);
		}
		return TRUE;

	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		EndPaint(hwnd, &ps);
		return 0;
	case WM_SIZE:
		return TRUE;
	case WM_CLOSE:
		EndDialog(hwnd, TRUE);
		break;

	case WM_LBUTTONDOWN:
		{
			g_xPos = GET_X_LPARAM(lParam); 
			g_yPos = GET_Y_LPARAM(lParam); 
			SetCapture(hwnd);
			break;
		}

	case WM_LBUTTONUP:
		{
			ReleaseCapture();
			break;
		}
	case WM_MOUSEMOVE:
		{
			if(wParam == MK_LBUTTON)
			{
				int xPos = GET_X_LPARAM(lParam); 
				int yPos = GET_Y_LPARAM(lParam); 
				int dx = xPos - g_xPos;
				int dy = yPos - g_yPos;

				set_move_method(0, g_pIDispatch);
				set_pos(-dx / 2,  g_pIDispatch, L"x");
				set_pos( dy / 2,  g_pIDispatch, L"y");
				move_trackerpod(g_pIDispatch);

				g_xPos = xPos;
				g_yPos = yPos;
			}

			break;
		}
	}
	return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.

	CoInitialize(NULL);

	HRESULT hr = CoCreateInstance( CLSID_TrackerPod, NULL, CLSCTX_INPROC_SERVER,
					IID_IDispatch, (void**) &g_pIDispatch);

	if(hr != S_OK || !g_pIDispatch)
	{
		CoInitialize(NULL);
		MessageBox(NULL, "Failed to initialize the component", "error", MB_OK);
		return 0;
	}

	g_hInstance = hInstance;
	DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_TRACKERPOD_TEST), NULL, (DLGPROC)DialogProc);

	if(g_pIDispatch)
		g_pIDispatch->Release();
	g_pIDispatch = NULL;

	CoUninitialize();
	return 0;
}

